package config

type Wechat struct {
	AppId     string `mapstructure:"app-id" json:"app-id" yaml:"app-id"`             // 微信小程序appid
	AppSecret string `mapstructure:"app-secret" json:"app-secret" yaml:"app-secret"` // 微信小程序appsecret
	Token     string `mapstructure:"token" json:"token" yaml:"token"`                // 微信小程序appsecret
	AesKey    string `mapstructure:"aes-key" json:"aes-key" yaml:"aes-key"`          // 微信小程序appsecret
}

// Pays 微信支付配置
// 支持多商户配置
type Pays struct {
	Type      string `mapstructure:"type" json:"type" yaml:"type"`
	AliasName string `mapstructure:"alias-name" json:"alias-name" yaml:"alias-name"`
	Pay       `yaml:",inline" mapstructure:",squash"`
	Disable   bool `mapstructure:"disable" json:"disable" yaml:"disable"`
}

type Pay struct {
	AppId     string `mapstructure:"app-id" json:"app-id" yaml:"app-id"`             // 微信小程序appid
	MchId     string `mapstructure:"mch-id" json:"mch-id" yaml:"mch-id"`             // 微信小程序appsecret
	V3Key     string `mapstructure:"v3-key" json:"v3-key" yaml:"v3-key"`             // 微信小程序appsecret
	CertPath  string `mapstructure:"cert-path" json:"cert-path" yaml:"cert-path"`    // 微信小程序appsecret
	KeyPath   string `mapstructure:"key-path" json:"key-path" yaml:"key-path"`       // 微信小程序appsecret
	NotifyUrl string `mapstructure:"notify-url" json:"notify-url" yaml:"notify-url"` // 微信小程序appsecret
	SerialNo  string `mapstructure:"serial-no" json:"serial-no" yaml:"serial-no"`    // 微信小程序appsecret
}
