package request

import "git.echol.cn/loser/lckt/model/common/request"

type SendCodeReq struct {
	Phone string `json:"phone" form:"phone" vd:"@:len($)>0; msg:'手机号码不能为空'"`
}

type CodeLoginReq struct {
	Phone string `json:"phone" form:"phone" vd:"@:len($)>0; msg:'请输入手机号码'"`
	Code  string `json:"code" form:"code" vd:"@:len($)>0; msg:'请输入短信验证码'"`
}

type InviteLoginReq struct {
	Phone string `json:"phone" form:"phone" vd:"@:len($)>0; msg:'手机号码不能为空'"`
	Code  string `json:"code" form:"code" vd:"@:len($)>0; msg:'验证码不能为空'"`
	Type  string `json:"type" form:"type" vd:"@:len($)>0; msg:'邀请类型不能为空'"`
	Token string `json:"token" form:"token" vd:"@:len($)>0; msg:'token不能为空'"`
}

type WxLoginReq struct {
	OpenId    string `json:"openId" form:"openId" binding:"required"`
	NickName  string `json:"nickName" form:"nickName"`
	Gender    int    `json:"gender" form:"gender"`
	UnionId   string `json:"unionId" form:"unionId" binding:"required"`
	AvatarUrl string `json:"avatarUrl" form:"avatarUrl"`
	Province  string `json:"province" form:"province"`
	City      string `json:"city" form:"city"`
}

type BindWechatReq struct {
	Id      int    `json:"id" form:"id" vd:"@:len($)>0; msg:'id不能为空'"`
	Openid  string `json:"openid" form:"openid" vd:"@:len($)>0; msg:'OpenId不能为空'"`
	UnionId string `json:"unionId" form:"unionId" gorm:"type:varchar(64);comment:用户统一标识。针对一个微信开放平台帐号下的应用，同一用户的 unionid 是唯一的。"`
}

type BindPhoneReq struct {
	Id    int    `json:"id" form:"id" vd:"@:len($)>0; msg:'用户ID不能为空'"`
	Phone string `json:"phone" form:"phone" vd:"@:len($)>0; msg:'手机号码不能为空'"`
}

type GetUserListReq struct {
	request.PageInfo
	Type      int    `json:"type" form:"type"`
	UserLabel string `json:"user_label" form:"user_label" `
	Status    int    `json:"status" form:"status"`
	Name      string `json:"name" form:"name"`
}

type SetBalanceReq struct {
	Id      int     `json:"id" form:"id" vd:"@:len($)>0; msg:'用户ID不能为空'"`
	Balance float32 `json:"balance" form:"balance" vd:"@:len($)>0; msg:'余额不能为空'"`
}

type PwdLoginReq struct {
	Phone    string `json:"phone" form:"phone" vd:"@:len($)>0; msg:'手机号码不能为空'"`
	Password string `json:"password" form:"password" vd:"@:len($)>0; msg:'密码不能为空'"`
	NickName string `json:"nick_name" form:"nick_name"`
}

type RegisterReq struct {
	Phone     string `json:"phone" form:"phone" vd:"@:len($)>0; msg:'手机号码不能为空'"`
	Password  string `json:"password" form:"password" vd:"@:len($)>0; msg:'密码不能为空'"`
	NickName  string `json:"nick_name" form:"nick_name"`
	UserType  int8   `json:"user_type" form:"user_type" vd:"@:len($)>0; msg:'用户类型不能为空'"`
	UserLabel int64  `json:"user_label" form:"user_label" vd:"@:len($)>0; msg:'用户标签不能为空'"`
}
