package user

import "git.echol.cn/loser/lckt/global"

type User struct {
	global.GVA_MODEL
	NickName string `json:"nick_name" form:"nick_name" gorm:"comment:用户昵称"`
	Phone    string `json:"phone" form:"phone" gorm:"comment:用户手机号"`
	UnionId  string `json:"union_id" form:"union_id" gorm:"type:varchar(255) comment '微信UnionId'"`
	OpenId   string `gorm:"column:open_id;default:'';comment:'openId'" json:"-"`
	Password string `json:"password" form:"password" gorm:"comment:用户密码"`
	Avatar   string `json:"avatar" form:"avatar" gorm:"comment:用户头像"`
	Status   int8   `gorm:"column:status;default:1;NOT NULL;comment:'用户状态  0 封禁 1 正常'" json:"status" form:"status"`
	//邀请码
	InviteCode    *string `json:"invite_code" form:"invite_code" gorm:"type:varchar(255) comment '用户专属邀请码'"`
	Balance       float32 `json:"balance" form:"balance" gorm:"type:decimal(10,2);comment:学员余额"`
	CommenderId   int     `json:"commender_id" form:"commender_id" gorm:"comment:推荐人ID"`
	UserLabel     int64   `json:"user_label" form:"user_label" gorm:"comment:用户标签 1 普通用户 2 Vip 3 Svip"`
	UserType      int8    `gorm:"column:user_type;default:1;NOT NULL;comment:'用户类型  1 用户 2 讲师'" json:"user_type" form:"user_type" `
	IsVip         int8    `gorm:"column:is_vip;default:0;NOT NULL;comment:'是否是VIP 0 否 1 是'" json:"is_vip" form:"is_vip"`
	VipExpireTime string  `json:"vip_expire_time" form:"vip_expire_time" gorm:"comment:VIP过期时间"`
}

func (User) TableName() string {
	return "app_user"
}
