package router

import (
	"git.echol.cn/loser/lckt/middleware"
	"git.echol.cn/loser/lckt/plugin/customerservice/api"
	serMiddleware "git.echol.cn/loser/lckt/plugin/customerservice/middleware"
	"github.com/gin-gonic/gin"
)

type CustomerServiceRouter struct {
}

func (s *CustomerServiceRouter) InitCustomerServiceRouter(Router *gin.RouterGroup) {
	wsRouter := Router.Group("")
	plugServiceRouter := Router.Group("").Use(serMiddleware.JWTAuthMiddleware()).Use(middleware.Cors())
	//plugRouter := Router.Group("").Use(middleware.JWTAuth())
	privateRouter := Router.Group("").Use(middleware.JWTAuth()).Use(middleware.CasbinHandler())
	plugAdminApi := api.ApiGroupApp.AdminServiceApi
	{
		privateRouter.GET("/service/get_service_list", plugAdminApi.GetServiceList)
		privateRouter.POST("/service/save_service", plugAdminApi.SaveService)
		privateRouter.DELETE("/service/delete_service", plugAdminApi.DeleteService)
		privateRouter.GET("/service/find_service", plugAdminApi.FindService)
		privateRouter.GET("/service/admin_login", plugAdminApi.AdminServiceLogin)
		privateRouter.GET("/service/get_script_list", plugAdminApi.GetScriptList)
		privateRouter.POST("/service/save_script", plugAdminApi.SaveScript)
		privateRouter.DELETE("/service/delete_script", plugAdminApi.DeleteScript)
		privateRouter.GET("/service/find_script", plugAdminApi.FindScript)
		privateRouter.GET("/service/auto_reply_list", plugAdminApi.AutoReplyList)
		privateRouter.POST("/service/save_reply", plugAdminApi.SaveReply)
		privateRouter.DELETE("/service/delete_reply", plugAdminApi.DeleteReply)
		privateRouter.GET("/service/find_reply", plugAdminApi.FindReply)
	}
	plugApi := api.ApiGroupApp.CustomerServiceApi
	{
		plugServiceRouter.POST("/service/send_msg", plugApi.SendMsg)
		plugServiceRouter.GET("/service/get_msg_list", plugApi.GetMsgList)
		plugServiceRouter.GET("/service/get_kf_info", plugApi.GetKefuInfo)
		plugServiceRouter.POST("/service/upload_file", plugApi.UploadFile)
		plugServiceRouter.GET("/service/get_user_info", plugApi.GetUserInfo)
		plugServiceRouter.GET("/service/get_msg_user", plugApi.GetMsgUser)
		plugServiceRouter.GET("/service/get_service_script", plugApi.GetServiceScript)
		plugServiceRouter.GET("/service/set_msg_view", plugApi.SetMsgView)
	}
	wsRouter.GET("/service/serve_ws", plugApi.ServeWsForKefu)
	wsRouter.GET("/service/ws", plugApi.ServeWs)
	wsRouter.POST("/service/account_login", plugAdminApi.AccountServiceLogin)
}
