package article

import (
	"git.echol.cn/loser/lckt/middleware"
	"github.com/gin-gonic/gin"
)

type ArticleRouter struct{}

// InitBotRouter 初始化 文章 路由信息
func (s *ArticleRouter) InitBotRouter(Router *gin.RouterGroup, PublicRouter *gin.RouterGroup) {
	articleRouter := Router.Group("article").Use(middleware.OperationRecord())
	articleRouterWithoutRecord := Router.Group("article")
	articleRouterWithoutAuth := PublicRouter.Group("article")
	{
		articleRouter.POST("", artApi.Create)   // 新建文章
		articleRouter.DELETE("", artApi.Delete) // 批量删除文章
		articleRouter.PUT("", artApi.Update)    // 更新文章

	}
	{
		articleRouterWithoutRecord.GET(":id", artApi.ById) // 根据ID获取文章
		articleRouter.GET("list", artApi.List)             // 获取文章列表
	}
	{
		articleRouterWithoutAuth.GET("", artApi.ById) // 文章开放接口
	}
}
