package category

import (
	"git.echol.cn/loser/lckt/middleware"
	"github.com/gin-gonic/gin"
)

type CategoryRouter struct{}

// InitCategoryRouter 初始化 类别 路由信息
func (s *CategoryRouter) InitCategoryRouter(Router *gin.RouterGroup, PublicRouter *gin.RouterGroup) {
	catRouter := Router.Group("cat").Use(middleware.OperationRecord())
	catRouterWithoutRecord := Router.Group("cat")
	catRouterWithoutAuth := PublicRouter.Group("cat")
	{
		catRouter.POST("createCategory", catApi.CreateCategory)             // 新建类别
		catRouter.DELETE("deleteCategory", catApi.DeleteCategory)           // 删除类别
		catRouter.DELETE("deleteCategoryByIds", catApi.DeleteCategoryByIds) // 批量删除类别
		catRouter.PUT("updateCategory", catApi.UpdateCategory)              // 更新类别
	}
	{
		catRouterWithoutRecord.GET("findCategory", catApi.FindCategory)       // 根据ID获取类别
		catRouterWithoutRecord.GET("getCategoryList", catApi.GetCategoryList) // 获取类别列表
	}
	{
		catRouterWithoutAuth.GET("getCategoryPublic", catApi.GetCategoryPublic) // 类别开放接口
	}
}
