package user

import (
	"git.echol.cn/loser/lckt/middleware"
	"github.com/gin-gonic/gin"
)

type UserRouter struct{}

// InitUserRouter 初始化 用户相关 路由信息
func (s *UserRouter) InitUserRouter(Router *gin.RouterGroup, PublicRouter *gin.RouterGroup) {
	userRouter := Router.Group("app_user").Use(middleware.OperationRecord())
	{
		userRouter.GET("list", userApi.GetUserList)         // 获取用户列表
		userRouter.PUT("setBalance", userApi.SetBalance)    // 更新用户余额
		userRouter.POST("register", userApi.Register)       // 注册
		userRouter.PUT("status/:id", userApi.SetUserStatus) // 更新用户状态
		userRouter.GET(":id", userApi.GetUserById)          // 获取用户信息
	}
}

func (s *UserRouter) InitAppUserRouter(PublicRouter *gin.RouterGroup) {
	appUserRouter := PublicRouter.Group("h5_user").Use(middleware.UserJWTAuth())
	{
		appUserRouter.DELETE("login", userApi.Login)       // 短信验证码登录
		appUserRouter.POST("sms/send", userApi.SendCode)   // 发送短信验证码
		appUserRouter.POST("wxLogin", userApi.WechatLogin) // 微信登录
		appUserRouter.POST("pwdlogin", userApi.PwdLogin)   // 密码登录
		appUserRouter.GET(":id", userApi.GetUserById)      // 获取用户信息
	}
}
