package vip

import (
	"git.echol.cn/loser/lckt/middleware"
	"github.com/gin-gonic/gin"
)

type VipRouter struct{}

// InitVipRouter 初始化会员路由
func (s *VipRouter) InitVipRouter(Router *gin.RouterGroup, PublicRouter *gin.RouterGroup) {
	vipRouter := Router.Group("vip").Use(middleware.OperationRecord())
	vipNoAuthRouter := PublicRouter.Group("vip").Use(middleware.OperationRecord())
	{
		vipRouter.POST("", vipApi.Create)   // 获取用户列表
		vipRouter.DELETE("", vipApi.Delete) // 更新用户余额
		vipRouter.PUT("", vipApi.Update)    // 注册
	}
	{
		vipNoAuthRouter.GET(":id", vipApi.GetVipById)  // 根据获取vip信息
		vipNoAuthRouter.GET("list", vipApi.GetVipList) // 获取会员列表
	}
}
